#
# pbx97.R, 11 May 16
#
# Data from:
# THE ECONOMICS OF OBJECT-ORIENTED SOFTWARE
# April 14, 1997
# Capers Jones, Chairman

pbx=read.csv("/web/pbx97.csv")

par(las=1)
par(bty="l")
par(pch=3)

plot(pbx$LOC, pbx$TOTAL,
	xlab="LOC", ylab="Total effort (months)")

pbx_mod=glm(TOTAL ~ LOC, data=pbx[1:6, ])
pred=predict(pbx_mod)
lines(pbx$LOC[1:6], pred, col="red")

pbx_oo_mod=glm(TOTAL ~ LOC, data=pbx[7:10, ])
pred_oo=predict(pbx_oo_mod)
lines(pbx$LOC[7:10], pred_oo, col="blue")
text(55000, 220, "OO languages", pos=4)
text(250000, 600, "non-OO languages", pos=2)

plot(pbx$LOC, pbx$Defects,
	xlab="LOC", ylab="Total defects")

pbx_mod=glm(Defects ~ LOC, data=pbx[1:6, ])
pred=predict(pbx_mod)
lines(pbx$LOC[1:6], pred, col="red")

pbx_oo_mod=glm(Defects ~ LOC, data=pbx[7:10, ])
pred_oo=predict(pbx_oo_mod)
lines(pbx$LOC[7:10], pred_oo, col="blue")
text(55000, 6000, "OO languages", pos=4)
text(250000, 10000, "non-OO languages", pos=2)
